package cn.com.qmth.stmms.api.controller.admin;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import com.qmth.boot.core.collection.PageResult;

import cn.com.qmth.stmms.api.controller.BaseApiController;
import cn.com.qmth.stmms.biz.basic.bean.RoleInfoQuery;
import cn.com.qmth.stmms.biz.basic.bean.RoleInfoVo;
import cn.com.qmth.stmms.biz.basic.bean.RolePrivilegeDomain;
import cn.com.qmth.stmms.biz.basic.bean.RolePrivilegeVo;
import cn.com.qmth.stmms.biz.basic.model.Privilege;
import cn.com.qmth.stmms.biz.basic.service.PrivilegeService;
import cn.com.qmth.stmms.biz.basic.service.RoleInfoService;
import cn.com.qmth.stmms.biz.basic.service.RolePrivilegeService;
import cn.com.qmth.stmms.biz.utils.PageUtil;
import cn.com.qmth.stmms.common.domain.WebUser;
import cn.com.qmth.stmms.common.enums.Role;
import cn.com.qmth.stmms.common.utils.RequestUtils;
import net.sf.json.JSONArray;

@Controller
@RequestMapping("/api/admin/role")
public class RoleController extends BaseApiController {

    @Autowired
    private RoleInfoService roleInfoService;

    @Autowired
    private RolePrivilegeService rolePrivilegeService;

    @Autowired
    private PrivilegeService privilegeService;

    @ResponseBody
    @RequestMapping(value = "page", method = RequestMethod.POST)
    public PageResult<RoleInfoVo> getPage(RoleInfoQuery query) {
        Integer totalCount = roleInfoService.countByQuery(query);
        query.setTotalCount(totalCount);
        if (totalCount > 0) {
            List<RoleInfoVo> list = roleInfoService.findByQuery(query);
            return PageUtil.of(list, query);
        } else {
            return PageUtil.emptyPage();
        }
    }

    @ResponseBody
    @RequestMapping(value = "list/all", method = RequestMethod.POST)
    public List<RoleInfoVo> getAll(@RequestParam Integer schoolId) {
        return roleInfoService.allList(schoolId);
    }

    @ResponseBody
    @RequestMapping(value = "privilege")
    public String privilege(Model model, HttpServletRequest request, RoleInfoQuery query) {
        List<RolePrivilegeVo> ps = rolePrivilegeService.findByQuery(query);
        if (ps != null) {
            model.addAttribute("privilegeList", JSONArray.fromObject(ps).toString());
        } else {
            model.addAttribute("privilegeList", "[]");
        }
        model.addAttribute("schoolId", query.getSchoolId());
        model.addAttribute("roleCode", query.getRole());
        model.addAttribute("roleName", Role.valueOf(query.getRole()).getName());
        return "modules/basic/rolePrivilege";
    }

    @ResponseBody
    @RequestMapping(value = "privilege/save")
    public String privilegeSave(RolePrivilegeDomain domain) {
        WebUser wu = getWebUser();
        domain.setUserId(wu.getId());
        rolePrivilegeService.save(domain);
        return "redirect:/admin/basic/role/info/list?schoolId=" + domain.getSchoolId();
    }

}
